%{?!python_module:%define python_module() python3-%{**}}
%define         skip_python2 1
%define _pyproject_wheeldir .
%define debug_package %{nil}
%define pyproject_buildrequires %{nil}

%global __requires_exclude_from ^%{_docdir}/.*$
#filter complex require that breaks urpmi
%global __requires_exclude ^.*tornado.*$

Name:           python-jupyterlab
Version:        2.1.2
Release:        %mkrel 5
Summary:        Environment for interactive and reproducible computing
License:        BSD-3-Clause
Group:          Development/Python
URL:            https://github.com/jupyterlab/jupyterlab
Source0:        https://files.pythonhosted.org/packages/py3/j/jupyterlab/jupyterlab-%{version}-py3-none-any.whl
Source99:       python-jupyterlab-rpmlintrc
BuildRequires:  %{python_module jupyterlab-server >= 1.0.0}
BuildRequires:  %{python_module jupyter-notebook >= 4.3.1}
BuildRequires:  %{python_module pip}
BuildRequires:  jupyter-jupyterlab-filesystem
BuildRequires:  jupyter-notebook-filesystem
BuildRequires:  nodejs >= 10
BuildRequires:  npm >= 10
Requires:       jupyter-jupyterlab = %{version}
Requires:       python3-jinja2 >= 2.10
Requires:       python >= 3.5
Requires:       python3-jupyter-core
Requires:       python3-jupyterlab-server >= 1.0.0
Requires:       python3-jupyter-notebook >= 4.3.1
Provides:       python3-jupyter_jupyterlab = %{version}
Obsoletes:      python3-jupyter_jupyterlab < %{version}
BuildArch:      noarch
# SECTION test requirements
BuildRequires:  %{python_module jinja2 >= 2.10}
#BuildRequires:  %{python_module pytest-check-links}
BuildRequires:  %{python_module pytest}
BuildRequires:  %{python_module requests}

%description
An extensible environment for interactive and reproducible computing,
based on the Jupyter Notebook and Architecture.

JupyterLab is the next-generation user interface for Project Jupyter
offering all the familiar building blocks of the classic Jupyter
Notebook (notebook, terminal, text editor, file browser, rich outputs,
etc.).

%package     -n python3-jupyterlab
Summary:        Environment for interactive and reproducible computing
Provides:       python-jupyterlab = %{version}-%{release}
Requires:       python3-tornado

%description -n python3-jupyterlab
An extensible environment for interactive and reproducible computing,
based on the Jupyter Notebook and Architecture.

JupyterLab is the next-generation user interface for Project Jupyter
offering all the familiar building blocks of the classic Jupyter
Notebook (notebook, terminal, text editor, file browser, rich outputs,
etc.).

%package     -n jupyter-jupyterlab
Summary:        Environment for interactive and reproducible computing
Requires:       python3-jupyter-core
Requires:       jupyter-jupyterlab-filesystem
Requires:       jupyter-jupyterlab-server >= 1.0.0
Requires:       jupyter-notebook >= 4.3.1
Requires:       nodejs >= 10
Requires:       npm >= 10
Requires:       python3-jupyterlab = %{version}
Provides:       jupyter-jupyterlab-discovery = 6
Obsoletes:      jupyter-jupyterlab-discovery < 6

%description -n jupyter-jupyterlab
An extensible environment for interactive and reproducible computing,
based on the Jupyter Notebook and Architecture.

JupyterLab is the next-generation user interface for Project Jupyter
offering all the familiar building blocks of the classic Jupyter
Notebook (notebook, terminal, text editor, file browser, rich outputs,
etc.). 

%prep
%setup -q -c -T

%build
# not needed

%install
mkdir -p dist
cp -a %{SOURCE0} dist
%py3_install_wheel jupyterlab-%{version}-py3-none-any.whl

%{jupyter_move_config}
sed -i -e 's|^#!/usr/bin/env node|#!%{_bindir}/node|' %{buildroot}%{python3_sitelib}/jupyterlab/node-version-check.js
sed -i -e 's|^#!/usr/bin/env node|#!%{_bindir}/node|' %{buildroot}%{python3_sitelib}/jupyterlab/staging/yarn.js
chmod a+x %{buildroot}%{python3_sitelib}/jupyterlab/node-version-check.js
chmod a+x %{buildroot}%{python3_sitelib}/jupyterlab/staging/yarn.js

cp %{buildroot}%{python3_sitelib}/jupyterlab-%{version}.dist-info/LICENSE .

#remove complex requires that breaks urpmi
#sed -i %{buildroot}%{python3_sitelib}/jupyterlab-%{version}.dist-info/METADATA -e 's/^Requires-Dist:\s+tornado.*/Requires-Dist: tornado >= 6.0.3/'


%check
export PYTHONDONTWRITEBYTECODE=1
# Disable build checks that pull in remote resources with npm
pytest %{buildroot}%{python3_sitelib}/jupyterlab/ -k \
    'not (test_build or test_clear or test_build_check or test_build_custom or test_uninstall_core_extension or test_install_and_uninstall_pinned or test_install_and_uninstall_pinned_folder or test_install_extension)'


%files -n python3-jupyterlab
%license %{python3_sitelib}/jupyterlab-%{version}.dist-info/LICENSE
%{python3_sitelib}/jupyterlab/
%{python3_sitelib}/jupyterlab-%{version}.dist-info/

%files -n jupyter-jupyterlab
%{_bindir}/jlpm
%{_bindir}/jupyter-lab
%{_bindir}/jupyter-labextension
%config %{_jupyter_servextension_confdir}/jupyterlab.json
%{_jupyter_lab_dir}


%changelog
* Wed May 20 2020 joequant <joequant> 2.1.2-5.mga8
+ Revision: 1586467
- remove tornado requires

* Wed May 20 2020 joequant <joequant> 2.1.2-4.mga8
+ Revision: 1586446
- fix up autorequires

* Wed May 20 2020 joequant <joequant> 2.1.2-3.mga8
+ Revision: 1586294
- fix version of pyproject

* Tue May 19 2020 joequant <joequant> 2.1.2-2.mga8
+ Revision: 1586162
- redo deps

* Tue May 19 2020 joequant <joequant> 2.1.2-1.mga8
+ Revision: 1586130
- add pyproject-rpm-macros
- imported package python-jupyterlab

